<?php
/*
Plugin Name: Facebook Dashboard Widget
Plugin URI: http://mou.me.uk/projects/wordpress/plugins/facebookdashboardwidget/
Description: Display your friends latest status updates and/or notifications on your WordPress dashboard.  Make sure you enter your feed details on <a href="options-general.php?page=facebook-dashboard-widget/fdw.php">the options page</a>.
Version: 0.8
Author: Chris Chrisostomou
Author URI: http://mou.me.uk/
*/

// **********************************************************************
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
// **********************************************************************


// Add the default options on plugin activation (if they don't already exist)
register_activation_hook(__FILE__, fdw_init);
function fdw_init() {
	if ( get_option('fdw_showupdates') == "" ) { add_option("fdw_showupdates", $value = "no", $deprecated = "", $autoload = "yes"); }
	if ( get_option('fdw_updatesfeed') == "" ) { add_option("fdw_updatesfeed", $value = "", $deprecated = "", $autoload = "yes"); }
	if ( get_option('fdw_updatesmax') == "" ) { add_option("fdw_updatesmax", $value = "5", $deprecated = "", $autoload = "yes"); }
	if ( get_option('fdw_updatesheight') == "" ) { add_option("fdw_updatesheight", $value = "single", $deprecated = "", $autoload = "yes"); }
	if ( get_option('fdw_updateswidth') == "" ) { add_option("fdw_updateswidth", $value = "half", $deprecated = "", $autoload = "yes"); }
	if ( get_option('fdw_shownotifications') == "" ) { add_option("fdw_shownotifications", $value = "no", $deprecated = "", $autoload = "yes"); }
	if ( get_option('fdw_notificationsfeed') == "" ) { add_option("fdw_notificationsfeed", $value = "", $deprecated = "", $autoload = "yes"); }
	if ( get_option('fdw_notificationsmax') == "" ) { add_option("fdw_notificationsmax", $value = "5", $deprecated = "", $autoload = "yes"); }
	if ( get_option('fdw_notificationsheight') == "" ) { add_option("fdw_notificationsheight", $value = "single", $deprecated = "", $autoload = "yes"); }
	if ( get_option('fdw_notificationswidth') == "" ) { add_option("fdw_notificationswidth", $value = "half", $deprecated = "", $autoload = "yes"); }
}


$fdw = new fdw;

class fdw {
	
	var $updates_show;
	var $updates_feed;
	var $updates_max;
	var $updates_height;
	var $updates_width;
	var $notifications_show;
	var $notifications_feed;
	var $notifications_max;
	var $notifications_height;
	var $notifications_width;
	
	function fdw() {
		$this -> updates_show = get_option('fdw_showupdates');
		$this -> updates_feed = get_option('fdw_updatesfeed');
		$this -> updates_max = get_option('fdw_updatesmax');
		$this -> updates_height = get_option('fdw_updatesheight');
		$this -> updates_width = get_option('fdw_updateswidth');
		$this -> notifications_show = get_option('fdw_shownotifications');
		$this -> notifications_feed = get_option('fdw_notificationsfeed');
		$this -> notifications_max = get_option('fdw_notificationsmax');
		$this -> notifications_height = get_option('fdw_notificationsheight');
		$this -> notifications_width = get_option('fdw_notificationswidth');
		if ( $this -> updates_show == "" || $this -> updates_max == "" || $this -> updates_height == "" || $this -> updates_width == "" || $this -> notifications_show == "" || $this -> notifications_max == "" || $this -> notifications_height == "" || $this -> notifications_width == "" ) {
			fdw_init();
		}
	}
	
	function get_statuses() {
		global $fdw;
		$rss = @ fetch_rss($this->updates_feed);
		if ($rss) {
			$items = array_slice($rss->items, 0, $this->updates_max);
			echo '<ul>';
			foreach ( $items as $item ) {
				echo '<li><span style="font-weight:bold;"><a href="' . $item['link'] . '">' . $item['title'] . '</a></span><br /><span style="font-size: 10px;">' . $this -> when_posted($item['pubdate']) . '</span></li>';
			}
			echo '</ul>';
		} else {
			if ( $this->updates_feed == "" ) {
				echo  '<p>You need to enter your Facebook feed URL in order to grab your status updates!</p>';
			} else {
				echo '<p>We\'re unable to grab your Facebook feed at this time.  Are you sure you\'ve entered it correctly?</p>';
			}
			echo  '<p>Check <a href="options-general.php?page=facebook-dashboard-widget/fdw.php">the options page</a> for more information.</p>';
		}
	}
	
	function get_notifications() {
		global $fdw;
		$rss = @ fetch_rss($this->notifications_feed);
		if ($rss) {
			$items = array_slice($rss->items, 0, $this->notifications_max);
			echo '<ul>';
			foreach ( $items as $item ) {
				echo '<li><span style="font-weight:bold;"><a href="' . $item['link'] . '">' . $item['title'] . '</a></span></li>';
			}
			echo '</ul>';
			
			
		} else {
			if ( $this->notifications_feed == "" ) {
				echo  '<p>You need to enter your Facebook feed URL in order to grab your status updates!</p>';
			} else {
				echo '<p>We\'re unable to grab your Facebook feed at this time.  Are you sure you\'ve entered it correctly?</p>';
			}
			echo  '<p>Check <a href="options-general.php?page=facebook-dashboard-widget/fdw.php">the options page</a> for more information.</p>';
		}
	}
	
	function when_posted($pubdate) {
		$a = "";
		$pubdate = strtotime($pubdate);
		$now = time();
		$difference = $now - $pubdate;
		
		$days = floor($difference / 84600);
		$difference -= 84600 * floor($difference / 84600);
		
		$hours = floor($difference / 3600);
		$difference -= 3600 * floor($difference / 3600);
		
		$minutes .= floor($difference / 60);
		$seconds = $difference - (60 * floor($difference / 60));
		
		if ( $days > 0 ) {
			$a .= $days . " day";
			if ( $day > 1 ) {
				echo "s";
			}
			$a .= " ago";
			return $a;
		}
		if ( $hours > 0 ) {
			$a .= $hours . " hour";
			if ( $hours > 1 ) {
				$a .= "s";
			}			
			if ($hours > 2) {
				$a .= " ago";
				return $a;
			} else {
				$a .= ", ";
			}
		}
		if ( $minutes > 0 ) {
			$a .= $minutes . " minute";
			if ( $minutes > 1 ) {
				$a .= "s";
			}
			if ( $minutes > 2 ) {
				$a .= " ago";
				return $a;
			} else {
				$a .= ", ";
			}
		}
		$a .= $seconds . " seconds ago";	
		return $a;
	}
	
}

if ( $fdw -> updates_show == "yes" ) {
	add_action('wp_dashboard_setup', 'fdw_updates_register_dashboard_widget');
	add_filter('wp_dashboard_widgets', 'fdw_updates_add_dashboard_widget');
}

if ( $fdw -> notifications_show == "yes" ) {
	add_action('wp_dashboard_setup', 'fdw_notifications_register_dashboard_widget');
	add_filter('wp_dashboard_widgets', 'fdw_notifications_add_dashboard_widget');
}


### Function: Register Dashboard Widget
function fdw_updates_register_dashboard_widget() {
	global $fdw;
	wp_register_sidebar_widget('dashboard_fdw_updates', __('Facebook Friends Status Updates', 'fdw_updates'), 'dashboard_fdw_updates',
		array(
		'all_link' => 'http://www.facebook.com/friends/',
		'feed_link' => $fdw -> updates_feed,
		'width' => $fdw -> updates_width,
		'height' => $fdw -> updates_height,
		)
	);
}

function fdw_notifications_register_dashboard_widget() {
	global $fdw;
	wp_register_sidebar_widget('dashboard_fdw_notifications', __('Facebook Notifications', 'fdw_notifications'), 'dashboard_fdw_notifications',
		array(
		'all_link' => 'http://www.facebook.com/friends',
		'feed_link' => $fdw -> notifications_feed,
		'width' => $fdw -> notifications_width,
		'height' => $fdw -> notifications_height,
		)
	);
}

 
// Add Dashboard Widget
function fdw_updates_add_dashboard_widget($widgets) {
	global $wp_registered_widgets;
	if (!isset($wp_registered_widgets['dashboard_fdw_updates'])) {
		return $widgets;
	}
	array_splice($widgets, sizeof($widgets)-1, 0, 'dashboard_fdw_updates');
	return $widgets;
}
function fdw_notifications_add_dashboard_widget($widgets) {
	global $wp_registered_widgets;
	if (!isset($wp_registered_widgets['dashboard_fdw_notifications'])) {
		return $widgets;
	}
	array_splice($widgets, sizeof($widgets)-1, 0, 'dashboard_fdw_notifications');
	return $widgets;
}
 
// Display Updates Dashboard Widget
function dashboard_fdw_updates($sidebar_args) {
	global $wpdb, $fdw;
	
	extract($sidebar_args, EXTR_SKIP);
	echo $before_widget;
	echo $before_title;
	echo $widget_name;
	echo $after_title;
	$fdw -> get_statuses();
	echo $after_widget;
}

// Display Notifications Dashboard Widget
function dashboard_fdw_notifications($sidebar_args) {
	global $wpdb, $fdw;
	
	extract($sidebar_args, EXTR_SKIP);
	echo $before_widget;
	echo $before_title;
	echo $widget_name;
	echo $after_title;
	$fdw -> get_notifications();
	echo $after_widget;
}

// Options Page
function fdw_options() {
	global $fdw;
	?>
    <div class="wrap">
		<?php if ( get_option('fdw_first') == "" ) { ?>
			<div class="updated fade" id="message" style="background-color: rgb(255, 251, 204);"><p><strong>Hope you enjoy the plugin!  If you feel like donating a little bit to show how much you like it, I have some <a href="#donate">paypal links at the bottom of this page</a>.  <sub>Psst, you won't see this message again!  ;o)</sub></strong></p></div>
			<?php 
			add_option("fdw_first", $value = "no", $deprecated = "", $autoload = "yes");
		}
		?>
		
		
		<form method="post" action="options.php" style="margin-bottom: 60px;">
			<h2><?php echo __('Facebook Dashboard Widget Options', 'fdw') ?></h2>
			<?php wp_nonce_field('update-options') ?>
			
			<h3>Friends Status Updates</h3>
			<table class="form-table" style="margin: 5px 0 20px;">
				<tr>
					<th>Display Status Updates Widget?</th>
					<td>
						<select name="fdw_showupdates">
							<option value="no"<?php if ( $fdw->updates_show == "no" ) { echo ' selected="selected"'; } ?>>No</option>
							<option value="yes"<?php if ( $fdw->updates_show == "yes" ) { echo ' selected="selected"'; } ?>>Yes</option>
						</select>
						 <em>Make sure you enter your feed URL before activating - for more information on how, <a href="#updates">see below</a></em>
					</td>
				</tr>
				<tr>
					<th>Status Updates Feed URL:</th>
					<td><input type="text" name="fdw_updatesfeed" value="<?php echo $fdw->updates_feed; ?>" size="105" /> <a href="#updates">?</a></td>
				</tr>
				<tr>
					<th>Number of updates to show:</th>
					<td>
						<select name="fdw_updatesmax">
							<?php
							for ($a=5; $a<=30; $a++) {
								echo '<option value="' . $a . '"';
								if ( $a == $fdw->updates_max ) {
									echo ' selected="selected"';
								}
								echo '>' . $a . '</option>';
							}
							?>
						</select>
					</td>
				</tr>
				<tr>
					<th>Widget Height:</th>
					<td>
						<select name="fdw_updatesheight">
							<option value="single"<?php if ( $fdw->updates_height == "single" ) { echo ' selected="selected"'; } ?>>Single</option>
							<option value="double"<?php if ( $fdw->updates_height == "double" ) { echo ' selected="selected"'; } ?>>Double</option>
						</select>
					</td>
				</tr>
				<tr>
					<th>Widget Width:</th>
					<td>
						<select name="fdw_updateswidth">
							<option value="half"<?php if ( $fdw->updates_width == "half" ) { echo ' selected="selected"'; } ?>>Single</option>
							<option value="full"<?php if ( $fdw->updates_width == "full" ) { echo ' selected="selected"'; } ?>>Double</option>
						</select>
					</td>
				</tr>
			</table>
			
			<h3>Notifications</h3>
			<table class="form-table" style="margin: 5px 0;">
				<tr>
					<th>Display Notifications Widget?</th>
					<td>
						<select name="fdw_shownotifications">
							<option value="no"<?php if ( $fdw->notifications_show == "no" ) { echo ' selected="selected"'; } ?>>No</option>
							<option value="yes"<?php if ( $fdw->notifications_show == "yes" ) { echo ' selected="selected"'; } ?>>Yes</option>
						</select>
						 <em>Make sure you enter your feed URL before activating - for more information on how, <a href="#notifications">see below</a></em>
					</td>
				</tr>
				<tr>
					<th>Status Notifications Feed URL:</th>
					<td><input type="text" name="fdw_notificationsfeed" value="<?php echo $fdw->notifications_feed; ?>" size="105" /> <a href="#notifications">?</a></td>
				</tr>
				<tr>
					<th>Number of updates to show:</th>
					<td>
						<select name="fdw_notificationsmax">
							<?php
							for ($b=5; $b<=10; $b++) {
								echo '<option value="' . $b . '"';
								if ( $b == $fdw->notifications_max ) {
									echo ' selected="selected"';
								}
								echo '>' . $b . '</option>';
							}
							?>
						</select>
					</td>
				</tr>
				<tr>
					<th>Widget Height:</th>
					<td>
						<select name="fdw_notificationsheight">
							<option value="single"<?php if ( $fdw->notifications_height == "single" ) { echo ' selected="selected"'; } ?>>Single</option>
							<option value="double"<?php if ( $fdw->notifications_height == "double" ) { echo ' selected="selected"'; } ?>>Double</option>
						</select>
					</td>
				</tr>
				<tr>
					<th>Widget Width:</th>
					<td>
						<select name="fdw_notificationswidth">
							<option value="half"<?php if ( $fdw->notifications_width == "half" ) { echo ' selected="selected"'; } ?>>Single</option>
							<option value="full"<?php if ( $fdw->notifications_width == "full" ) { echo ' selected="selected"'; } ?>>Double</option>
						</select>
					</td>
				</tr>
			</table>
            <input type="hidden" name="action" value="update" />
            <input type="hidden" name="page_options" value="fdw_showupdates, fdw_updatesfeed, fdw_updatesmax, fdw_updatesheight, fdw_updateswidth, fdw_shownotifications, fdw_notificationsfeed, fdw_notificationsmax, fdw_notificationsheight, fdw_notificationswidth" />
            <p class="submit"><input type="submit" name="Submit" value="<?php _e('Update Options »') ?>" /></p>
	    </form>
	
		<h2><a name="updates"></a>How to find your Status Updates feed</h2>
		<p><span style="font-size: 24px; font-weight: bold;">1. </span> Log into facebook, and click the "Friends" tab at the top of your page (as below)</p>
		<img src="<?php echo bloginfo('wpurl'); ?>/wp-content/plugins/facebook-dashboard-widget/images/updates-1.gif" />
		<p><span style="font-size: 24px; font-weight: bold;">2.</span> Look at the bottom of the right hand sidebar for a link marked "Friends' Status Feed".</p>
		<p><span style="font-size: 24px; font-weight: bold;">3.</span> Right click on the link, and select "Copy Link Location" (if you're using Firefox) or "Copy Shortcut" (if you're using Internet Explorer).  The link can now be pasted into the box on the form at the top of this page.</p>
		<img src="<?php echo bloginfo('wpurl'); ?>/wp-content/plugins/facebook-dashboard-widget/images/updates-2.gif" />
		<img src="<?php echo bloginfo('wpurl'); ?>/wp-content/plugins/facebook-dashboard-widget/images/updates-2-1.gif" />
		
		<h2 style="margin-top: 30px;"><a name="notifications"></a>How to find your notifications feed</h2>
		<p><span style="font-size: 24px; font-weight: bold;">1. </span> Log into facebook, click the arrow next to the "Inbox" tab at the top of your page and select the "Notifications" option from the drop down menu (as below)</p>
		<img src="<?php echo bloginfo('wpurl'); ?>/wp-content/plugins/facebook-dashboard-widget/images/notifications-1.gif" />
		<p><span style="font-size: 24px; font-weight: bold;">2.</span> Look on the right hand sidebar for a link marked "Your Notifications".</p>
		<p><span style="font-size: 24px; font-weight: bold;">3.</span> Right click on the link, and select "Copy Link Location" (if you're using Firefox) or "Copy Shortcut" (if you're using Internet Explorer).  The link can now be pasted into the box on the form at the top of this page.</p>
		<img src="<?php echo bloginfo('wpurl'); ?>/wp-content/plugins/facebook-dashboard-widget/images/notifications-2.gif" />
		<img src="<?php echo bloginfo('wpurl'); ?>/wp-content/plugins/facebook-dashboard-widget/images/notifications-2-1.gif" />
		
		<h2 style="margin-top: 60px;"><a name="donate"></a>Donate</h2>
		<p>This plugin is provided free under a GPL license, which means you can use, share, alter, change and generally mess around with to your hearts content -   and completely for free!  But if you like this plugin and would like to throw £1 or £2 my way, it'd take some of the strain away from spending entire weekends in front of my laptop  ;o)</p>
		<p>But whether you choose to donate or not, I hope you enjoy the plugin!</p>
		<p>
		<form name="_xclick" action="https://www.paypal.com/cgi-bin/webscr" method="post" target="_blank">
		<input type="hidden" name="cmd" value="_xclick">
		<input type="hidden" name="business" value="cezuk@aol.com">
		<input type="hidden" name="item_name" value="FDW Donation">
		<input type="hidden" name="currency_code" value="GBP">
		<input type="hidden" name="amount" value="2.00">
		<input type="image" src="http://www.paypal.com/en_US/i/btn/btn_donate_LG.gif" border="0" name="submit" alt="Make payments with PayPal - it's fast, free and secure!"> £2.00
		</form>
		</p>
		<p>
		<form name="_xclick" action="https://www.paypal.com/cgi-bin/webscr" method="post" target="_blank">
		<input type="hidden" name="cmd" value="_xclick">
		<input type="hidden" name="business" value="cezuk@aol.com">
		<input type="hidden" name="item_name" value="FDW Donation">
		<input type="hidden" name="currency_code" value="GBP">
		<input type="hidden" name="amount" value="1.00">
		<input type="image" src="http://www.paypal.com/en_US/i/btn/btn_donate_LG.gif" border="0" name="submit" alt="Make payments with PayPal - it's fast, free and secure!"> £1.00
		</form>
		</p>
		<p>
		<form name="_xclick" action="https://www.paypal.com/cgi-bin/webscr" method="post" target="_blank">
		<input type="hidden" name="cmd" value="_xclick">
		<input type="hidden" name="business" value="cezuk@aol.com">
		<input type="hidden" name="item_name" value="FDW Donation">
		<input type="hidden" name="currency_code" value="GBP">
		<input type="image" src="http://www.paypal.com/en_US/i/btn/btn_donate_LG.gif" border="0" name="submit" alt="Make payments with PayPal - it's fast, free and secure!" style="margin: 0;">
		£<input type="text" name="amount" value="" size="20">
		</form>
		</p>
	</div>
    <?php
}

function fdw_menus() {
	if (current_user_can('manage_options')) {
		if (function_exists('add_options_page')) {
			add_options_page(__('Facebook Dashboard Widget', 'fdw'), __('Facebook Dashboard Widget', 'fdw'), 8, __FILE__, 'fdw_options');
		}
	}
}

add_action('admin_menu', 'fdw_menus');


?>